/*! \file pitransparentdevice.h
 * \brief PIIODevice that pass write to read
*/
/*
	PIP - Platform Independent Primitives
	PIIODevice that pass write to read
	Ivan Pelipenko peri4ko@yandex.ru

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PITRANSPARENTDEVICE_H
#define PITRANSPARENTDEVICE_H

#include "piiodevice.h"


class PIP_EXPORT PITransparentDevice: public PIIODevice
{
	PIIODEVICE(PITransparentDevice)
public:
	
	//! Contructs empty %PITransparentDevice
	explicit PITransparentDevice();
	
	virtual ~PITransparentDevice();
	
protected:
	bool openDevice();
	bool closeDevice();
	int readDevice(void * read_to, int max_size);
	int writeDevice(const void * data, int max_size);
	PIString fullPathPrefix() const {return PIStringAscii("tr");}
	DeviceInfoFlags deviceInfoFlags() const {return PIIODevice::Reliable;}

	PIMutex que_mutex;
	PIQueue<PIByteArray> que;

};

#endif // PITRANSPARENTDEVICE_H
